﻿; MediaPortal Tray Launcher
ProgName    = MediaPortal Tray Launcher
ProgVer     = 0.5
ProgPage    = http://www.solykz.11vm-serv.net/travaux/mediaportal/mediaportal-tray-launcher/


; -----
; Script settings
; -----
#SingleInstance, Force
#NoEnv
#NoTrayIcon
#Persistent
SendMode Input

; Program Files directory access
ProgramFilesDir := A_ProgramFiles . (A_PtrSize = 8 ? " (x86)" : "")

; MediaPortal directory access
MPPath = %ProgramFilesDir%\Team MediaPortal\MediaPortal

; MediaPortal launch command
MPLaunchCommand = "MediaPortal.exe"

; Tray icon presence
TrayIcon := true

; Custom screen selection
CustomScreen := false
CustomScreenNumber = 0

; Automatically run MediaPortal on MediaPortal Tray Launcher startup
Autorun := false



; -----
; Command line parameters fetch
; -----
Loop, %0%
{
    if (%A_Index% == "/hide") {
        TrayIcon := false
    }
    
	if (%A_Index% == "/autorun") {
        Autorun := true
    }
    
	if SubStr(%A_Index%, 1, 6) == "/path="
    {
        CustomPath := SubStr(%A_Index%, 7)
        IfNotExist, %CustomPath%\MediaPortal.exe
        {
            MsgBox, 16, %ProgName% %ProgVer%: Incorrect path selection, The custom path specified in the command line is incorrect. You have to specify the MediaPortal installation directory. e.g.:`n`n          MPtray.exe /path="%MPPath%"`n`n`nSorry for the inconvenience.
            ExitApp
            return
        }
        MPPath = %CustomPath%
    }
    
	if SubStr(%A_Index%, 1, 8) == "/screen="
    {
        CustomScreen = true
        CustomScreenNumber := SubStr(%A_Index%, 9)
        
        if CustomScreenNumber is not integer
        {
            MsgBox, 16, %ProgName% %ProgVer%: Incorrect screen selection, The custom screen specified in the command line is incorrect. You have to specify a screen number, starting from 0, according to your configuration. e.g.:`n`n          MPtray.exe /screen="1"`n`n`nSorry for the inconvenience.
            ExitApp
            return
        }
    }
}



; -----
; MediaPortal command line parameters support
; -----
if !(CustomScreen == false) {
    MPLaunchCommand = %MPLaunchCommand% /screen=%CustomScreenNumber%
}



; -----
; Additional features
; -----
IfNotExist, %MPPath%\MediaPortal.exe
{
    MsgBox, 16, %ProgName% %ProgVer%: Error while accessing MediaPortal, MediaPortal Tray Launcher was unable to access the MediaPortal executable. Please check your MediaPortal installation or specify a custom access path in the command line. e.g.:`n`n          MPtray.exe /path="C:\foo\bar\MediaPortal"`n`n`nSorry for the inconvenience.
    ExitApp
    return
}

if (TrayIcon == true) {
    Menu, tray, Icon
    
    ; Systray icon
    Menu, Tray, Icon, MPTray.exe
    Menu, Tray, Tip, %ProgName% %ProgVer%

    ; Systray menu
    Menu, Tray, NoStandard
    Menu, Tray, Add, Launch MediaPortal..., StartMediaPortal
    Menu, Tray, Add, About..., About
    Menu, Tray, Add, Exit, Exit
}

; Automatically launch MediaPortal if asked
if (Autorun == true) {
	run %MPLaunchCommand%, %MPPath%, max
}

; Empty unused memory
EmptyMem()

; End of auto-execution process
return



; -----
; Systray menu related commands
; -----
; Exit
Exit:
ExitApp
return

; Start MediaPortal
StartMediaPortal:
run %MPLaunchCommand%, %MPPath%, max
EmptyMem()
return

; About window
About:
Gui, Destroy
Gui, +AlwaysOnTop
Gui, Add, Picture, x16 y14 w100 h100, MPTray.exe
Gui, Font, S16 CDefault Bold
Gui, Add, Text, x126 y14 w340 h30, %ProgName% %ProgVer%
Gui, Font,
Gui, Font, cBlue underline
Gui, Add, Text, x376 y39 w80 h20 ggetAboutPage, By SolykZ`, 2014
Gui, Font,
Gui, Font, S10, 
Gui, Add, Text, x126 y69 w330, Simply launch MediaPortal with the green Start button of your remote control.
Gui, Font,
Gui, Font, cBlue underline
Gui, Add, Text, x16 y129 w220 h20 ggetLicencePage, Under Creative Commons licence BY-NC 3.0
Gui, Font,
Gui, Add, Button, x406 y124 w50, OK
Gui, Show, Autosize Center NoActivate, %ProgName% %ProgVer%
return

ButtonOK:
Gui, Destroy
return

getLicencePage:
run http://creativecommons.org/licenses/by-nc/3.0/
return

getAboutPage:
run %ProgPage%
return



; -----
; Magic stuff that reduce memory usage
; -----
EmptyMem(PID="AHK Rocks") {
    pid := (pid="AHK Rocks") ? DllCall("GetCurrentProcessId") : pid
    h := DllCall("OpenProcess", "UInt", 0x001F0FFF, "Int", 0, "Int", pid)
    DllCall("SetProcessWorkingSetSize", "UInt", h, "Int", -1, "Int", -1)
    DllCall("CloseHandle", "Int", h)
}



; -----
; Okay, THIS is the main line of the program
; -----
!#Enter::run %MPLaunchCommand%, %MPPath%, max